{  simg -- utilities for the simg package
   Version 20220317
   Copyright (C) 1999-2022 Stefan Ziegenbalg
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see http://www.gnu.org/licenses/.
!}

(*
  Options:
     dos  : newline=#13#10
     unix : newline=#10
     auto : auto detect newline (using getdir)
     rmc  : output after first '}' (to remove the copyright note)
*)
var s,nl   : ansistring;
    fo,i   : longint;
    ch     : char;

begin
    getdir(0,s);
    if s[1]='/' then nl:=#10
    else nl:=#13#10;
    fo:=0;
    for i:=1 to paramcount do
        if paramstr(i)='dos' then nl:=#13#10
        else if paramstr(i)='unix' then nl:=#10
        else if paramstr(i)='rmc' then fo:=2
        else if paramstr(i)<>'auto' then
        begin
            writeln(stderr,'illegal option: '+paramstr(i));
            halt(1);
        end;
    ch:=#0;
    while not eof(input) do
    begin
        readln(s);
        { remove trailing whitespaces }
        while (length(s)>0) and (s[length(s)]<=#32) do
            delete(s,length(s),1);
        { re-format tabs }
        i:=1;
        while i<=length(s) do
            if s[i]=#9 then
            begin
                delete(s,i,1);
                repeat
                    insert(#32,s,i);
                    inc(i);
                until (i-1) mod 8=0;
            end
            else inc(i);
        { output }
        if (fo=1) and (s<>'') then fo:=0;
        if fo=0 then write(s,nl);
        if (fo>1) and ((s='!}') or (s='%!}')) then fo:=1;
    end;
end.
