{  simg -- image processing library
   Version 20220317
   Copyright (C) 1999-2022 Stefan Ziegenbalg
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see http://www.gnu.org/licenses/.
!}

{*************************************************************************}
{******* types ***********************************************************}
{*************************************************************************}
//define[asm_single][dword]
//define[asm_double][qword]

//define[preclimit(][,#1)][//ifdef[doubleprec]
#1
//nolf
//else
#0
//nolf
//endif
]

//define[divlimit][preclimit(1e-15,1e-150)]
//define[reslimit][preclimit(1e-7,1e-15)]
//define[notzero2(][,#1);][
if abs(#0)<#1 then
   begin
   if #0<0 then #0:=-#1
           else #0:=#1;
   end;
]
//define[notzero(][);][notzero2(#0,divlimit);]


{*************************************************************************}
{******* funny kernel macros *********************************************}
{*************************************************************************}
//define[_IOC_NRBITS][8];
//define[_IOC_TYPEBITS][8];
//define[_IOC_SIZEBITS][14];
//define[_IOC_DIRBITS][2];

//define[_IOC_NRSHIFT][0]
//define[_IOC_TYPESHIFT][(_IOC_NRSHIFT+_IOC_NRBITS)]
//define[_IOC_SIZESHIFT][(_IOC_TYPESHIFT+_IOC_TYPEBITS)]
//define[_IOC_DIRSHIFT][(_IOC_SIZESHIFT+_IOC_SIZEBITS)]

//define[_IOC(][,#1,#2,#3);][((#0 shl _IOC_DIRSHIFT) or (#1 shl _IOC_TYPESHIFT) or (#2 shl _IOC_NRSHIFT) or (#3 shl _IOC_SIZESHIFT))]

//define[_IOW(][,#1,#2)][_IOC(1,ord(#0),#1,sizeof(#2));]
//define[_IOR(][,#1,#2)][_IOC(2,ord(#0),#1,sizeof(#2));]
//define[_IOWR(][,#1,#2)][_IOC(3,ord(#0),#1,sizeof(#2));]

